//+------------------------------------------------------------------+
//|                                                 BandsOnArray.mq4 |
//|                                   Copyright  2008, Serega Lykov |
//|                                       http://mtexperts.narod.ru/ |
//|  BollingerBands  -   () |
//+------------------------------------------------------------------+

//    BollingerBands   RSI.
//    ,    -  

#property copyright "Copyright  2008, Serega Lykov"
#property link      "http://mtexperts.narod.ru/"

//----   ------------------------------------------+
//        BB,
//       
#property indicator_separate_window  // BB       ( CCI, RSI, MACD  ..)
//#property indicator_chart_window   // BB         ( MA, BollingerBands  ..)

//   : 3  BB,   ,    BB
//   = 8
#property indicator_buffers 4        // 3 (BB) + 1 (RSI)
//     BB
#property indicator_color1 SeaGreen  //    BB
#property indicator_color2 SeaGreen  //    BB
#property indicator_color3 SeaGreen  //    BB
//         BB
#property indicator_color4 Red       //      BB

//----   --------------------------------------------+
//   BollingerBands
extern int    BandsPeriod     = 20;  //  
extern int    BandsMethod     = 0;   //  : 0 = Simple,   1 = Exponential,
                                     //                   2 = Smoothed, 3 = Weighted
extern int    BandsShift      = 0;   //     
extern double BandsDeviations = 2.0; // 
//      BB
extern int    RSIPeriod       = 14;  //  RSI
extern int    RSIPrice        = 0;   //   RSI: 0 = PRICE_CLOSE, 1 = PRICE_OPEN,
                                     // 2 = PRICE_HIGH,     3 = PRICE_LOW,   4 = 0PRICE_MEDIAN,
                                     // 5 = PRICE_TYPICAL,  6 = PRICE_WEIGHTED

//----  ------------------------------------------------------+
//     BollingerBands
double MiddleBuffer[];               //     BB
double UpperBuffer[];                //     BB
double LowerBuffer[];                //     BB
//        BB
double RSIBuffer[];                  //     RSI

//----   ----------------------------------------+
//     

//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int init()
  {
//----  ""  
   IndicatorShortName("Bands("+BandsPeriod+","+DoubleToStr(BandsDeviations,2)+") On RSI"+"("+RSIPeriod+")");
//----    
   IndicatorDigits(Digits);          //  ,     
//----   
   SetLevelValue(0,70);              //  indicator_chart_window,
   SetLevelValue(1,30);              //    
   SetLevelValue(2,50);              // ,  -    
//----    BollingerBands
   //    
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
   //     
   SetIndexBuffer(0,MiddleBuffer);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexBuffer(2,LowerBuffer);
   //      
   SetIndexDrawBegin(0,RSIPeriod+BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,RSIPeriod+BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,RSIPeriod+BandsPeriod+BandsShift);
   //    
   SetIndexLabel(0,"MiddleBB");
   SetIndexLabel(1,"UpperBB");
   SetIndexLabel(2,"LowerBB");
//----        BB
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(3,RSIBuffer);
   SetIndexDrawBegin(3,RSIPeriod);
   SetIndexLabel(3,"RSI");
//----  
   return(0);
  }

//+------------------------------------------------------------------+
//| Bollinger Bands On Array                                         |
//+------------------------------------------------------------------+
int start()
  {
   //     ,    
   if(Bars <= RSIPeriod+BandsPeriod) return(0);
   //       
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) return(-1);
   //     
   if(counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
//----        BB
   for(int i=limit; i>=0; i--)
     {
      RSIBuffer[i] = iRSI(NULL,0,RSIPeriod,RSIPrice,i);
     }
//----   BB   
   for(i=0; i<limit; i++) MiddleBuffer[i] = iMAOnArray(RSIBuffer,0,BandsPeriod,BandsShift,BandsMethod,i);
   while(i >= 0)
     {
      double sum = 0.0;
      int k = i + BandsPeriod - 1;
      double oldval = MiddleBuffer[i];
      while(k >= i)
        {
         double newres = RSIBuffer[k] - oldval;
         sum = sum + newres * newres;
         k--;
        }
      double deviation = BandsDeviations * MathSqrt(sum/BandsPeriod);
      UpperBuffer[i] = oldval + deviation;
      LowerBuffer[i] = oldval - deviation;
      i--;
     }
//----
   return(0);
  }

//+------------------------------------------------------------------+